
#include once ".\book.bas"
#include once ".\matesolver.bas"

extern "C" lib ".\simplechessplayer"
  declare function BestMove stdcall alias "BestMove" (byval positionData as string) as string
end extern

dim shared bookLoaded as boolean
bookLoaded = false

function ChessPlayerMove(byval positionData as string, byref moveLabel as string) as string
  dim result as string = ""
  dim moveOk as boolean = false
  
  if BookLoaded then
    result = BookMove(positionData)
    if len(result) = 4 then
      moveOk = true
      moveLabel = "opening book"
    end if
  end if
  
  if not moveOk then
    result = *SolveMate(positionData, 3, SEARCH_ALL_MOVES)
    if len(result) = 4 then
      moveOk = true
      moveLabel = "mate solver"
    end if
  end if
  
  if not moveOk then
    result = BestMove(positionData)
    if len(result) = 4 then
      moveOk = true
      moveLabel = "simple chess player"
    end if
  end if
  
  if not moveOk then
    result = ""
    moveLabel = "chess player could not find any move to play"
  end if
  
  return result
end function
